<template>
  <with-aside>
    <template slot="aside">
      <el-menu router :default-active="$route.path" :collapse="collapse" background-color="#848c94">
        <el-menu-item index="/settings/profile">
          <router-link to="/settings/profile" class="aside-link">
            <font-awesome-icon :icon="icon('user')" /> <span>Profile</span></router-link>
        </el-menu-item>
        <el-menu-item index="/settings/emails">
          <router-link to="/settings/emails" class="aside-link">
            <font-awesome-icon :icon="icon('email')" /> <span>Emails</span></router-link>
        </el-menu-item>
        <el-menu-item index="/settings/password">
          <router-link to="/settings/password" class="aside-link">
            <font-awesome-icon :icon="icon('password')" /> <span>Password</span></router-link>
        </el-menu-item>
        <el-menu-item index="/settings/account">
          <router-link to="/settings/account" class="aside-link">
            <font-awesome-icon :icon="icon('account')" /> <span>Account</span></router-link>
        </el-menu-item>
        <el-menu-item index="#collapse" @click="toggle" class="collapse">
          <font-awesome-icon :icon="icon(collapse ? 'expand' : 'collapse')" /> <span>Collapse</span>
        </el-menu-item>
      </el-menu>
    </template>

    <slot></slot>
  </with-aside>
</template>

<script>
import FontAwesomeIcon from '@fortawesome/vue-fontawesome'
import faUser from '@fortawesome/fontawesome-free-solid/faUser'
import faEnvelope from '@fortawesome/fontawesome-free-solid/faEnvelope'
import faLock from '@fortawesome/fontawesome-free-solid/faLock'
import faUserCircle from '@fortawesome/fontawesome-free-solid/faUserCircle'
import faAngleDoubleLeft from '@fortawesome/fontawesome-free-solid/faAngleDoubleLeft'
import faAngleDoubleRight from '@fortawesome/fontawesome-free-solid/faAngleDoubleRight'
import WithAsideLayout from './with_aside'

export default {
  components: { 'with-aside': WithAsideLayout, FontAwesomeIcon },

  data() {
    return {
      collapse: false
    }
  },

  methods: {
    icon(name) {
      switch(name){
        case 'user':
        return faUser
        case 'email':
        return faEnvelope
        case 'password':
        return faLock
        case 'account':
        return faUserCircle
        case 'collapse':
        return faAngleDoubleLeft
        case 'expand':
        return faAngleDoubleRight
      }
    },

    toggle() {
      this.collapse = this.collapse ? false : true
    }
  }
}
</script>
